// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

/**
* Assert class that throws an exception when an
* assertion fails.
*/
public class Assert 
{
    public static boolean ENABLED = true;

    private Assert() 
    {
    }

    public static void assert(Object o, boolean condition, String failureDescription)
    {
        if (!condition)
        {
            String s = "Assertion failed";
            String name = className(o);
            if (name.length() > 0)
            {
                s += " in " + className(o);
            }
            if (failureDescription != null)
            {
                s += ": " + failureDescription;
            }
            throw new AssertException(s);
        }
    }

    public static void assert(Object o, boolean condition) 
    {
        assert(o,condition,null);
    }

    /**
    * Gets the name of the class represented by an object.
    * Null objects cause an empty string to be returned.
    */
    private static String className(Object o)
    {
        if (o != null)
        {
            return(o.getClass().getName());
        }
        else
        {
            return("");
        }
    }

    static class AssertException extends RuntimeException
    {
        AssertException(String s)
        {
            super(s);
        }
    }
}



