// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

public abstract class BaseCommand implements Command
{
    private JTContext _context = null;
    private Logger _logger = null;

    public abstract String getName();

    public abstract String getDescription();

    public abstract String getUsage();

    public boolean isHidden()
    {
        return false;
    }

    public JTContext getContext()
    {
        return _context;
    }

    public void setContext(JTContext context)
    {
        _context = context;
    }

    public Logger getLogger()
    {
        return _logger;
    }

    public void setLogger(Logger logger)
    {
        _logger = logger;
    }

    public abstract void setArgs(String[] args) throws Exception;

    public abstract void run() throws Exception;

    public void println(String s)
    {
        _logger.println(s);
    }

    public void println()
    {
        _logger.println();
    }
}
