// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

import java.util.*;

public class CommandFactory extends Object
{
    private static CommandFactory _instance;

    private Hashtable _commands = new Hashtable();

    private CommandFactory() {}

    public static CommandFactory instance()
    {
        if (_instance == null)
        {
            _instance = new CommandFactory();
        }

        return _instance;
    }

    public Vector getCommandNames()
    {
        Vector names = new Vector();

        for (Enumeration enum = _commands.keys(); enum.hasMoreElements(); )
        {
            String name = (String)enum.nextElement();
            names.addElement(name);
        }

        return names;
    }

    public void registerCommand(Class clas) throws IllegalAccessException, InstantiationException
    {
        Command command = null;

        command = (Command)clas.newInstance();
        _commands.put(command.getName(), command.getClass());
    }

    public boolean hasCommand(String name)
    {
        Class clas = (Class)_commands.get(name);
        return clas != null;
    }

    public Command createCommand(String name)
    {
        Class clas = (Class)_commands.get(name);

        Command command = null;

        if (clas != null)
        {            
            try
            {
                command = (Command)clas.newInstance();
            }
            catch (InstantiationException iex)
            {
                iex.printStackTrace();
            }
            catch (IllegalAccessException iaex)
            {
                iaex.printStackTrace();
            }
        }

        return command;
    }
}
