// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

import org.omg.CORBA.*;
import SessionManager.*;
import com.sybase.jaguar.system.Management;
import com.sybase.jaguar.system.ManagementHelper;
import com.sybase.jaguar.system.Repository;
import com.sybase.jaguar.system.RepositoryHelper;
import java.lang.Object;
import java.io.*;
import java.util.*;

public class JTContext extends Object
{
    private String _hostName    = JTConstants.DEFAULT_HOST;        
    private String _port        = JTConstants.DEFAULT_PORT;        
    private String _userName    = JTConstants.DEFAULT_USER;        
    private String _password    = JTConstants.DEFAULT_PASSWORD;    
    private String _commandFile = JTConstants.DEFAULT_COMMAND_FILE;

    private ORB _orb;
    private Manager _manager;
    private Session _session;
    private Repository _repository;
    private Management _management;

    private boolean _initialized = false;

    public JTContext() {}

    public String getHostName()
    {
        return _hostName;
    }

    public void setHostName(String hostName)
    {
        _hostName = hostName;
    }

    public String getPort()
    {
        return _port;
    }

    public void setPort(String port)
    {
        _port = port;
    }

    public String getUserName()
    {
        return _userName;
    }

    public void setUserName(String userName)
    {
        _userName = userName;
    }

    public String getPassword()
    {
        return _password;
    }

    public void setPassword(String password)
    {
        _password = password;
    }

    public String getCommandFile()
    {
        return _commandFile;
    }

    public void setCommandFile(String commandFile)
    {
        _commandFile = commandFile;
    }

    public boolean isInitialized()
    {
        return _initialized;
    }

    public void initialize()
    {
        Properties props = new Properties();
        props.put("org.omg.CORBA.ORBClass", "com.sybase.CORBA.ORB");

        _orb = ORB.init(new String[0], props);

        _manager = ManagerHelper.narrow(_orb.string_to_object("iiop://" + getHostName() + ":" + getPort()));
        _session = _manager.createSession(getUserName(), getPassword());
        _repository = RepositoryHelper.narrow(_session.create("Jaguar/Repository"));
        _management = ManagementHelper.narrow(_session.create("Jaguar/Management"));

        _initialized = true;
    }

    public ORB getORB()
    {
        if (_initialized == false)
        {
            initialize();
        }

        return _orb;
    }

    public Session getSession()
    {
        if (_initialized == false)
        {
            initialize();
        }

        return _session;
    }

    public Repository getRepository()
    {
        if (_initialized == false)
        {
            initialize();
        }

        return _repository;
    }

    public Management getManagement()
    {
        if (_initialized == false)
        {
            initialize();
        }

        return _management;
    }
}
