// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

/**
* Base exception for jagtool.
*/
public class JTException extends Exception
{
    private Command _command;
    private Exception _nestedException;

    public JTException(String msg)
    {
        super(msg);
    }

    public JTException(Command command)
    {
        super();
        _command = command;
    }

    public JTException(String msg, Command command)
    {
        super(msg);
        _command = command;
    }

    public JTException(String msg, Command command, Exception ex)
    {
        super(msg);
        _command = command;
        _nestedException = ex;
    }

    public Command getCommand()
    {
        return _command;
    }

    public Exception getNestedException()
    {
        return _nestedException;
    }
}

