// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool;

import java.util.ListResourceBundle;

/**
 * Resource bundle for package com.sybase.jaguar.managment.jagtool.
 */
public class ResourceBundle extends ListResourceBundle
{
    /**
     * Return the entire contents of the resource bundle.
     * @return  two dimension array of pairs <key>,<value>
     */
    public Object[][] getContents()
    {
        return contents;
    }

    /**
     * The array that holds the actual resources in a form <key>,<value>.
     */
    static final Object[][] contents = 
    {
        { "jagtoolName", "jagtool" },
        { "jagtoolDesc", "Tool for managing Jaguar servers" },
        { "jagtoolUsage", "[-host hostname] [-port port] [-user username] [-password password] command\n" +
          "\n" +
          "-host (or -h)\n" +
          "   Name of Jaguar host (default: localhost)\n" +
          "-port (or -n)\n" +
          "   Port number for Jaguar host (default: 9000)\n" +
          "-user (or -u)\n" +
          "   Jaguar user name (default: jagadmin)\n" +
          "-password (or -p)\n" +
          "   Jaguar password (default: none)\n" +
          "command\n" +
          "   Command to execute\n" +
          "\n" +
          "Commands are:\n" },
        { "jagtoolCommandDesc", "{0} - {1}" },
        { "jagtoolCommandUsage", "usage: {0} {1}" },
        { "jagtoolCommandMsg", "{0}: {1}" },
        { "cannotFindCommandsFileMsg", "Cannot find {0}" },
        { "cannotLoadCommandsFileMsg", "Cannot load {0}" },
        { "noClassSpecifiedForCommandMsg", "Warning: No class specified for command {0}" },
        { "cannotLoadCommandClassMsg", "Warning: Cannot load class {0} for command {1}" },
        { "cannotRegisterCommandClassMsg", "Warning: Cannot register class {0} for command {1}" },
        { "missingValueMsg", "No {0} value specified" },
        { "invalidValueMsg", "Invalid {0} value: {1}" },
        { "unknownOptionMsg", "Unknown option: {0}" },
        { "invalidEntityTypeMsg", "Invalid entity type: {0}\nValid entity types are: {1}" },
        { "entityNotExistMsg", "{0} {1} does not exist" },
    };
}

