// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.ant;

import org.apache.tools.ant.BuildException;
import com.sybase.jaguar.management.jagtool.JTResourceManager;
import com.sybase.jaguar.management.jagtool.JTContext;

public class ConnectTask extends JagTask
{
    public static final String HOST_PROP     = "host";
    public static final String PORT_PROP     = "port";
    public static final String USER_PROP     = "user";
    public static final String PASSWORD_PROP = "password";

    private static JTResourceManager _resources =
    	new JTResourceManager(ConnectTask.class);

    private String _hostProp;
    private String _portProp;
    private String _userProp;
    private String _passwordProp;

    public void setHost(String hostProp) throws Exception
    {
        _hostProp = hostProp;
    }

    public void setPort(String portProp) throws Exception
    {
        _portProp = portProp;
    }

    public void setUser(String userProp) throws Exception
    {
        _userProp = userProp;
    }

    public void setPassword(String passwordProp) throws Exception
    {
        _passwordProp = passwordProp;
    }

    public void execute() throws BuildException
    {
        JTContext context = new JTContext();

        if (_hostProp != null)
        {
            context.setHostName(_hostProp);
        }

        if (_portProp != null)
        {
            context.setPort(_portProp);
        }

        if (_userProp != null)
        {
            context.setUserName(_userProp);
        }

        if (_passwordProp != null)
        {
            context.setPassword(_passwordProp);
        }

        try
        {
            context.initialize();
        }
        catch (Exception ex)
        {
            throw new BuildException(_resources.getString("connectFailMsg",
                new String[] { context.getHostName(), context.getPort() }), ex);
        }

        setSharedContext(context);

        log(_resources.getString("connectSuccessMsg",
            new String[] { context.getHostName(), context.getPort(), context.getUserName() }));
    }
}
