// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.ant;

import org.apache.tools.ant.BuildException;
import com.sybase.jaguar.management.jagtool.UsageException;
import com.sybase.jaguar.management.jagtool.commands.DeleteCommand;

public class DeleteTask extends JagTask
{
    private DeleteCommand _command;

    public void init()
    {
        _command = new DeleteCommand();
        _command.setLogger(new JagTaskLogger(this));
    }

    public void setEntity(String entityProp) throws Exception
    {
        try
        {
            _command.setEntity(entityProp);
        }
        catch (UsageException uex)
        {
            throw new BuildException(uex.getMessage(), uex);
        }
    }

    public void execute() throws BuildException
    {
        checkConnected();

        _command.setContext(getSharedContext());

        try
        {
            _command.run();
        }
        catch (Exception ex)
        {
            throw new BuildException(ex);
        }
    }
}
