// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.ant;

import java.util.*;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.Project;
import org.apache.tools.ant.Task;
import com.sybase.jaguar.management.jagtool.*;

/**
* Base task for integrating jagtool commands
* with Ant.
*
* @author tenglund
*/
public abstract class JagTask extends Task
{
    private static JTResourceManager _resources =
    	new JTResourceManager(ConnectTask.class);

    private static JTContext _sharedContext;

    /**
    * Returns the shared instance of JTContext.
    */
    protected JTContext getSharedContext()
    {
        return _sharedContext;
    }

    /**
    * Sets the shared instance of JTContext.
    */
    protected void setSharedContext(JTContext context)
    {
        _sharedContext = context;
    }

    /**
    * Checks that a connection is open to a Jaguar server.
    * Tasks derived from JagTask should call checkConnected
    * in their execute method before executing their command.
    */
    protected void checkConnected() throws BuildException
    {
        if (_sharedContext == null || !_sharedContext.isInitialized())
        {
            throw new BuildException(_resources.getString("notConnectedMsg"));
        }
    }

    /**
    * Execute method required by Ant.
    */
    public abstract void execute() throws BuildException;
}
