// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.ant;

import org.apache.tools.ant.BuildException;
import com.sybase.jaguar.management.jagtool.UsageException;
import com.sybase.jaguar.management.jagtool.commands.RemoveCommand;

public class RemoveTask extends JagTask
{
    private RemoveCommand _command;

    public void init()
    {
        _command = new RemoveCommand();
        _command.setLogger(new JagTaskLogger(this));
    }

    public void setSource(String sourceProp) throws Exception
    {
        try
        {
            _command.setSource(sourceProp);
        }
        catch (UsageException uex)
        {
            throw new BuildException(uex.getMessage(), uex);
        }
    }

    public void setTarget(String targetProp) throws Exception
    {
        try
        {
            _command.setTarget(targetProp);
        }
        catch (UsageException uex)
        {
            throw new BuildException(uex.getMessage(), uex);
        }
    }

    public void execute() throws BuildException
    {
        checkConnected();

        _command.setContext(getSharedContext());

        try
        {
            _command.run();
        }
        catch (Exception ex)
        {
            throw new BuildException(ex);
        }
    }
}
