// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import com.sybase.jaguar.management.common.*;
import com.sybase.jaguar.management.jagtool.*;
import com.sybase.jaguar.management.*;
import com.sybase.jaguar.importer.*;
import com.sun.enterprise.deployment.*;
import java.util.*;

public class DeployEarCommand extends BaseCommand
{
    private static LocalResourceManagerImpl _resources =
    	new LocalResourceManagerImpl(DeployEarCommand.class);

    private String _earFileName;

    public String getName()
    {
        return _resources.getString("deployEarName", "deploy_ear");
    }

    public String getHelp()
    {
        return _resources.getString("deployEarHelp", "");
    }

    public String getUsage()
    {
        return _resources.getString("deployEarUsage", "");
    }

    public void run(String[] args) throws Exception
    {
        if (args.length == 0)
        {
            usage();
            return;
        }
        else
        {
            _earFileName = args[0];
        }

        JRepository repository =
            new JRepository(JTGlobals.getUserName(),
                            JTGlobals.getPassword(),
                            JTGlobals.getHostName(),
                            JTGlobals.getPort(),
                            "rw");

        JEarImporter imprtr = null;

        DefaultStatusHandler statusHandler =
            new DefaultStatusHandler();

        try
        {
            imprtr = new JEarImporter(repository, _earFileName);

            imprtr.setStatusDialogInterface(statusHandler);

            if (imprtr.isApplication() || imprtr.isEJBJar())
            {
                for (Enumeration f = imprtr.getEJBBundleDescriptors(); f.hasMoreElements(); )
                {
                    EjbBundleDescriptor bdescriptor = 
                        (EjbBundleDescriptor) f.nextElement();

                    imprtr.deployEJBBundle(bdescriptor);
                }
            }

            if (imprtr.isApplication() || imprtr.isWar())
            {
                for (Enumeration f = imprtr.getWebBundleDescriptors(); f.hasMoreElements(); )
                {
                    WebBundleDescriptor bdescriptor = 
                        (WebBundleDescriptor) f.nextElement();

                    imprtr.deployWebAppBundle(bdescriptor);
                }
            }

//            JStubSkelGenerator gen = new JStubSkelGenerator(repository, statusHandler);
//
//            for (Enumeration f = imprtr.getEJBBundleDescriptors();
//                f.hasMoreElements(); )
//            {
//                EjbBundleDescriptor bdescriptor = 
//                    (EjbBundleDescriptor) f.nextElement();
//
//                String packName = bdescriptor.getName();
//                JPackage pack = repository.getPackage(packName);
//
//                pack.refreshComponents();
//
//                statusHandler.addConsoleMsg(_resources.getString("generatingSkelsForPackage",
//                    "Generating skeletons for package {0}",
//                    new Object[] { packName }));
//
//                gen.generateSkeletons(pack);
//            }
        }
        catch (Exception ex)
        {
            statusHandler.addConsoleMsg(_resources.getString("deployFailedMsg", "Deploy Failed"));
            throw ex;
        }
    }

}
