// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import com.sybase.jaguar.management.common.*;
import com.sybase.jaguar.management.jagtool.*;
import com.sybase.jaguar.management.*;
import com.sybase.jaguar.importer.*;
import com.sun.enterprise.deployment.*;
import java.util.*;

public class DeployWarCommand extends BaseCommand
{
    private static LocalResourceManagerImpl _resources =
    	new LocalResourceManagerImpl(DeployWarCommand.class);

    private String _warFileName;

    public String getName()
    {
        return _resources.getString("deployWarName", "deploy_war");
    }

    public String getHelp()
    {
        return _resources.getString("deployWarHelp", "");
    }

    public String getUsage()
    {
        return _resources.getString("deployWarUsage", "");
    }

    public void run(String[] args) throws Exception
    {
        if (args.length == 0)
        {
            usage();
            return;
        }
        else
        {
            _warFileName = args[0];
        }

        JRepository repository =
            new JRepository(JTGlobals.getUserName(),
                            JTGlobals.getPassword(),
                            JTGlobals.getHostName(),
                            JTGlobals.getPort(),
                            "rw");

        JEarImporter imprtr = null;

        DefaultStatusHandler statusHandler =
            new DefaultStatusHandler();

        try
        {
            imprtr = new JEarImporter(repository, _warFileName);

            imprtr.setStatusDialogInterface(statusHandler);

            if (imprtr.isApplication() || imprtr.isEJBJar())
            {
                for (Enumeration f = imprtr.getEJBBundleDescriptors(); f.hasMoreElements(); )
                {
                    EjbBundleDescriptor bdescriptor = 
                        (EjbBundleDescriptor) f.nextElement();

                    imprtr.deployEJBBundle(bdescriptor);
                }
            }

            if (imprtr.isApplication() || imprtr.isWar())
            {
                for (Enumeration f = imprtr.getWebBundleDescriptors(); f.hasMoreElements(); )
                {
                    WebBundleDescriptor bdescriptor = 
                        (WebBundleDescriptor) f.nextElement();

                    imprtr.deployWebAppBundle(bdescriptor);
                }
            }
        }
        catch (Exception ex)
        {
            statusHandler.addConsoleMsg(_resources.getString("deployFailedMsg", "Deploy Failed"));
            throw ex;
        }
    }

}
