// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import com.sybase.jaguar.management.common.*;
import com.sybase.jaguar.management.jagtool.*;
import com.sybase.jaguar.system.Management;
import com.sybase.jaguar.system.ManagementHelper;
import com.sybase.jaguar.system.Repository;
import com.sybase.jaguar.system.RepositoryHelper;

public class RefreshPackagesCommand extends BaseCommand
{
    private static LocalResourceManagerImpl _resources =
    	new LocalResourceManagerImpl(RefreshPackagesCommand.class);

    public String getName()
    {
        return _resources.getString("refreshPackagesName", "refresh_packages");
    }

    public String getHelp()
    {
        return _resources.getString("refreshPackagesHelp", "");
    }

    public String getUsage()
    {
        return _resources.getString("refreshPackagesUsage", "");
    }

    public void run(String[] args) throws Exception
    {    
        if (args.length == 0)
        {
            usage();
            return;
        }

        Repository rep = JTContext.getRepository();

        for (int i = 0; i < args.length; i++)
        {
            String packageName = args[i];

            boolean exists = rep.exists(JTConstants.PACKAGE_TYPE, packageName);

            if (exists == false)
            {
                System.out.println(_resources.getString("packageNotExistMsg",
                    "Warning: package {0} does not exist",
                    new String[] { packageName }));
            }
            else
            {
                Management management = JTContext.getManagement();
                management.refresh(JTConstants.PACKAGE_TYPE, packageName);    
                System.out.println(_resources.getString("refreshedPackageMsg",
                    "Refreshed package {0}",
                    new String[] { packageName }));
            }
        }
    }

}
