// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import java.util.ListResourceBundle;

public class ResourceBundle extends ListResourceBundle
{
    /**
     * Return the entire contents of the resource bundle.
     * @return  two dimension array of pairs <key>,<value>
     */
    public Object[][] getContents()
    {
        return contents;
    }

    /**
     * The array that holds the actual resources in a form <key>,<value>.
     */
    static final Object[][] contents = 
    {
        // deploy

        { "deployName", "deploy" },
        { "deployDesc", "Deploys a J2EE or Jaguar archive file to a Jaguar server" },
        { "deployUsage", "[-type filetype] [-skels true|false] filename\n" +
          "\n" +
          "-type\n" +
          "   Type of file being deployed: ear, war, ejbjar, or jagjar (default: ear)\n" +
          "-skels\n" +
          "   Automatically generate skeletons for EJBs (default: true)\n" +
          "filename\n" +
          "   Name of the file being deployed" },
        { "deployStartMsg", "Deploying..." },
        { "deploySuccessMsg", "Deployed file {0}" },
        { "deployFailedMsg", "Deploy Failed" },
        { "deployExceptionLoadingFile", "Exception loading file {0}" },
        { "deployInvalidFileTypeMsg", "Invalid {0} option {1} for file {2}" },
        { "deployNoSuchFile", "File {0} does not exist" },
        { "deployJagJarError", "Cannot deploy file {0}" },

        // help

        { "helpName", "help" },
        { "helpDesc", "Displays usage for a command" },
        { "helpHelpCommand", "For help on a particular command use: jagtool help command" },
        { "helpUsage", "[command]\n" +
          "\n" +
          "command\n" +
          "   Command of interest" },
        { "invalidCommandMsg", "{0} is not a valid command" },

        // refresh

        { "refreshName", "refresh" },
        { "refreshDesc", "Refreshes an entity in a server" },
        { "refreshUsage", "entity\n" +
          "\n" +
          "entity\n" +
          "   An entity id in the form entity_type:entity_name" },
        { "refreshedEntityMsg", "Refreshed {0} {1}" },

        // export

        { "exportName", "export" },
        { "exportDesc", "Exports an entity to a J2EE or Jaguar archive file" },
        { "exportUsage", "[-dir dirname] [-jagjar] entity\n" +
          "\n" +
          "-dir\n" +
          "   Directory where the file is created.  By default, the file \n" +
          "   is created in the current directory.\n" +
          "-jagjar\n" +
          "   Export to a Jaguar jar file instead of a J2EE file.\n" +
          "entity\n" +
          "   An entity id in the form entity_type:entity_name" },
        { "exportingMsg", "Exporting to file {0}" },
        { "exportSuccessMsg", "Exported {0} {1} to file {2}" },
        { "exportFailedMsg", "Export Failed" },
        { "exportFileExistsMsg", "File {0} already exists" },
        { "exportCannotCreateFileMsg", "Cannot create file {0}" },

        // delete

        { "deleteName", "delete" },
        { "deleteDesc", "Deletes an entity from the repository" },
        { "deleteUsage", "entity\n" +
          "\n" +
          "entity\n" +
          "   An entity id in the form entity_type:entity_name" },
        { "deletedEntityMsg", "Deleted {0} {1}" },
        { "deletedFailedMsg", "Cannot delete {0} {1}" },

        // list

        { "listName", "list" },
        { "listDesc", "Lists entities in the repository" },
        { "listUsage", "[type] [entity]\n" +
          "\n" +
          "Either a type or entity must be specified.  When no\n" +
          "entity is specified, the top-level entities of the\n" +
          "given type are listed.\n" +
          "\n" +
          "type\n" +
          "   Type of entities to list.\n" +
          "entity\n" +
          "   Entity id in the form entity_type:entity_name" },

        // props

        { "propsName", "props" },
        { "propsDesc", "Lists properties for an entity" },
        { "propsUsage", "entity\n" +
          "\n" +
          "entity\n" +
          "   An entity id in the form entity_type:entity_name" },

        // shutdown

        { "shutdownName", "shutdown" },
        { "shutdownDesc", "Shuts down a Jaguar server" },
        { "shutdownUsage", "\n" },
        { "shutdownMsg", "Shutdown {0} {1}" },

        // restart

        { "restartName", "restart" },
        { "restartDesc", "Restarts a Jaguar server" },
        { "restartUsage", "\n" },
        { "restartMsg", "Restarted {0} {1}" },

        // install

        { "installName", "install" },
        { "installDesc", "Installs an entity into another entity" },
        { "installUsage", "source target\n" +
          "\n" +
          "source\n" +
          "   Entity id for the source entity\n" +
          "target\n" +
          "   Entity id for the target entity\n" },
        { "installedEntityMsg", "Installed {0} {1} in {2} {3}" },
        { "installAlreadyInstalledMsg", "{0} {1} is already installed in {2} {3}" },
        { "installAlreadyInstalledMsg2", "Cannot install {0} {1} because it is already installed in {2} {3}" },
        { "installFailedMsg", "Cannot install {0} {1} in {2} {3}" },
        { "installAlreadyInstalledInServersMsg", "Cannot install {0} {1} because it is already installed in the following Servers: {2}" },

        // remove

        { "removeName", "remove" },
        { "removeDesc", "Removes an entity from another entity" },
        { "removeUsage", "source target\n" +
          "\n" +
          "source\n" +
          "   Entity id for the source entity\n" +
          "target\n" +
          "   Entity id for the target entity\n" },
        { "removedEntityMsg", "Removed {0} {1} from {2} {3}" },
        { "removeNotInstalledMsg", "{0} {1} is not installed in {2} {3}" },
        { "removeFailedMsg", "Cannot remove {0} {1} from {2} {3}" },

        // exists

        { "existsName", "exists" },
        { "existsDesc", "Determines whether an entity exists" },
        { "existsUsage", "entity\n" +
          "entity\n" +
          "   An entity id in the form entity_type:entity_name" },

        // other

        { "entityExistsMsg", "{0} {1} exists" },
        { "entityNotExistMsg", "{0} {1} does not exist" },
        { "invalidSourceEntityMsg", "Invalid source type {0} for target type {1}\nValid source types are: {2}" },
        { "invalidTargetEntityMsg", "Invalid target type {0}\nValid target types are: {1}" },
    };
}



