// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import java.io.*;
import java.util.*;
import com.sybase.jaguar.management.jagtool.*;
import com.sybase.jaguar.system.Management;
import com.sybase.jaguar.system.ManagementHelper;

/**
* Restarts a Jaguar server.
*/
public class RestartCommand extends BaseCommand
{
    private static JTResourceManager _resources =
    	new JTResourceManager(RestartCommand.class);

    public String getName()
    {
        return _resources.getString("restartName");
    }

    public String getDescription()
    {
        return _resources.getString("restartDesc");
    }

    public String getUsage()
    {
        return _resources.getString("restartUsage");
    }

    public void setArgs(String[] args) throws Exception
    {
        if (args.length > 0)
        {
            throw new UsageException(this);
        }
    }

    public void run() throws Exception
    {
        JTContext context = getContext();

        Management management = context.getManagement();

        String serverName = management.getServer();

        try
        {
            management.restart();
        }
        catch (org.omg.CORBA.COMM_FAILURE ignore) {}

        println(_resources.getString("restartMsg",
            new String[] { EntityIdentifier.SERVER_TYPE, serverName }));
    }
}
