// 
// Confidential property of Sybase, Inc.
// (c) Copyright Sybase, Inc. 2000.
// All rights reserved
// 
package com.sybase.jaguar.management.jagtool.commands;

import java.io.*;
import java.util.*;
import com.sybase.jaguar.management.jagtool.*;
import com.sybase.jaguar.system.Repository;
import com.sybase.jaguar.system.RepositoryHelper;
import com.sybase.jaguar.system.Management;
import com.sybase.jaguar.system.ManagementHelper;

/**
* Shuts down a Jaguar server.
*/
public class ShutdownCommand extends BaseCommand
{
    private static JTResourceManager _resources =
    	new JTResourceManager(ShutdownCommand.class);

    public String getName()
    {
        return _resources.getString("shutdownName");
    }

    public String getDescription()
    {
        return _resources.getString("shutdownDesc");
    }

    public String getUsage()
    {
        return _resources.getString("shutdownUsage");
    }

    public void setArgs(String[] args) throws Exception
    {
        if (args.length > 0)
        {
            throw new UsageException(this);
        }
    }

    public void run() throws Exception
    {
        JTContext context = getContext();
        Repository rep = context.getRepository();

        Management management = context.getManagement();

        String serverName = management.getServer();

        try
        {
            management.shutdown();
        }
        catch (org.omg.CORBA.COMM_FAILURE ignore) {}

        println(_resources.getString("shutdownMsg",
            new String[] { EntityIdentifier.SERVER_TYPE, serverName }));
    }
}
