package com.sybase.jaguar.sample.events;

import java.util.Hashtable;

class Hashqueue extends Hashtable
{
    private int _maximum;

    private long _oldestKey;
    
    private long _newestKey;
    
    public Hashqueue(int maximum)
    {
        _maximum = maximum;
        _oldestKey = 0;
        _newestKey = -1;
    }
    
    public synchronized Object put(Object key, Object value)
    {
        long longKey = ((Number)key).longValue();
        Object oldValue = super.put(new Long(longKey), value);
        if (longKey < _oldestKey)
        {
            _oldestKey = longKey;
        }
        if (longKey > _newestKey)
        {
            _newestKey = longKey;
        }
        while (this.size() > _maximum)
        {
            // Remove an element to reduce queue size
            this.remove(new Long(_oldestKey++));
        }
        return oldValue;
    }
    
    public synchronized Object get(Object key)
    {
        long longKey = ((Number)key).longValue();
        return super.get(new Long(longKey));
    }
    
    public synchronized Object remove(Object key)
    {
        long longKey = ((Number)key).longValue();
        return super.remove(new Long(longKey));
    }
    
    public Number oldest()
    {
        return new Long(_oldestKey);
    }
    
    public Number newest()
    {
        return new Long(_newestKey);
    }    
}
