package com.sybase.jaguar.sample.events;

import org.omg.CORBA.*;
import SessionManager.*;
import java.lang.Object;

public class OrderClient implements OrderStatusListener
{
    public static void main(String[] args) throws Exception
    {
        checkUsage(args);
        new OrderClient().run(args[0], Integer.parseInt(args[1]), args[2], args[3]);
    }

    static void checkUsage(String[] args)
    {
        if (args.length != 4)
        {
            System.out.println("Usage: java EventSamples.OrderClient <host> <port> <user> <password>");
            System.exit(0);
        }
    }

    void run(String host, int port, String user, String password) throws Exception
    {
        String[] args = { "-org.omg.CORBA.ORBClass", "com.sybase.CORBA.ORB" };
        ORB orb = ORB.init(args, null);
        Manager manager = ManagerHelper.narrow(orb.string_to_object("iiop://" + host + ":" + port));
        Session session = manager.createSession(user, password);
        OrderManager orderManager = OrderManagerHelper.narrow(session.create("EventSamples/OrderManager"));

        for (;;)
        {
            prompt();
            submit();
            int id = orderManager.newOrderId();
            Order order = new Order(id, "Aspirin", 20);
            orderManager.pushOrder(order);
            System.out.println("Submitted order " + id + ".");
            new PullOrderStatus(this, orderManager, id).start();
        }
    }

    void prompt()
    {
        System.out.print("Press Return to submit a new order... ");
        System.out.flush();
    }

    void submit() throws Exception
    {
        for (;;)
        {
            if (System.in.available() > 0)
            {
                //while (System.in.available() > 0) System.in.read();
                System.in.read();
                return;
            }
            Thread.sleep(1000);
        }
    }

    public void orderStatus(OrderStatus status)
    {
        System.err.println("\nNotification: order " + status.id + " was "
                           + (status.accepted ? "accepted" : "rejected") + ".");
        prompt();
    }
}
