package com.sybase.jaguar.sample.events;

import java.util.Vector;
import java.util.Hashtable;

public class OrderManagerImpl
{
    private static Vector _work = new Vector();

    private static Hashtable _done = new Hashtable();

    private static int _counter = 0;
    
    private static Object _lock = new Integer(0);

    public int newOrderId()
    {
        synchronized(_lock)
        {
            int id = ++_counter;
            return id;
        }
    }

    public void pushOrder
        (Order order)
    {
        synchronized(_work)
        {
            _work.addElement(order);
            _work.notifyAll();
        }
    }

    public Order pullOrder()
    {
        for (;;)
        {
            try
            {
                synchronized(_work)
                {
                    if (_work.size() != 0)
                    {
                        Order order = (Order)_work.elementAt(0);
                        _work.removeElementAt(0);
                        return order;
                    }
                    _work.wait();
                }
            }
            catch (InterruptedException ignore)
            {
            }
        }
    }

    public void pushOrderStatus
        (OrderStatus status)
    {
        synchronized(_done)
        {
            _done.put(new Integer(status.id), status);
            _done.notifyAll();
        }
    }

    public OrderStatus pullOrderStatus
        (int id)
    {
        for (;;)
        {
            try
            {
                synchronized(_done)
                {
                    OrderStatus status = (OrderStatus)_done.get(new Integer(id));
                    if (status != null)
                    {
                        _done.remove(new Integer(id));
                        return status;
                    }
                    _done.wait();
                }
            }
            catch (InterruptedException ignore)
            {
            }
        }
    }
}
