package com.sybase.jaguar.sample.events;

import org.omg.CORBA.*;
import SessionManager.*;
import java.lang.Object;

public class OrderOffice
{
    public static void main(String[] args) throws Exception
    {
        checkUsage(args);
        new OrderOffice().run(args[0], Integer.parseInt(args[1]), args[2], args[3]);
    }

    static void checkUsage(String[] args)
    {
        if (args.length != 4)
        {
            System.out.println("Usage: java EventSamples.OrderOffice <host> <port> <user> <password>");
            System.exit(0);
        }
    }

    void run(String host, int port, String user, String password) throws Exception
    {
        String[] args = { "-org.omg.CORBA.ORBClass", "com.sybase.CORBA.ORB" };
        ORB orb = ORB.init(args, null);
        Manager manager = ManagerHelper.narrow(orb.string_to_object("iiop://" + host + ":" + port));
        Session session = manager.createSession(user, password);
        OrderManager orderManager = OrderManagerHelper.narrow(session.create("EventSamples/OrderManager"));

        for (;;)
        {
            prompt();
            while (System.in.read() != '\n') ;
            Order order = orderManager.pullOrder();
            System.out.println("Processed order " + order.id + ".");
            OrderStatus status = new OrderStatus(order.id, true);
            orderManager.pushOrderStatus(status);
        }
    }

    void prompt()
    {
        System.out.print("Press Return to process a new order... ");
        System.out.flush();
    }
}
