package com.sybase.jaguar.sample.events;

import org.omg.CORBA.*;
import SessionManager.*;
import java.lang.Object;

public class StockOffice
{
    public static void main(String[] args) throws Exception
    {
        checkUsage(args);
        new StockOffice().run(args[0], Integer.parseInt(args[1]), args[2], args[3],
                              args[4], Double.valueOf(args[5]).doubleValue());
    }

    static void checkUsage(String[] args)
    {
        if (args.length != 6)
        {
            System.out.println("Usage: java EventSamples.StockOffice <host> <port> <user> <password> <stock> <value>");
            System.exit(0);
        }
    }

    void run(String host, int port, String user, String password, String stock, double value) throws Exception
    {
        String[] args = { "-org.omg.CORBA.ORBClass", "com.sybase.CORBA.ORB" };
        ORB orb = ORB.init(args, null);
        Manager manager = ManagerHelper.narrow(orb.string_to_object("iiop://" + host + ":" + port));
        Session session = manager.createSession(user, password);
        StockManager stockManager = StockManagerHelper.narrow(session.create("EventSamples/StockManager"));
        int id = stockManager.newStockEventId();
        StockEvent event = new StockEvent(id, stock, value);
        stockManager.pushStockEvent(event);
    }
}
