/*
 * $Id: EJBException.java,v 1.5 1999/10/30 08:08:18 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb;

/**
 * The EJBException exception is thrown by an enterprise Bean instance to 
 * its container to report that the invoked business method or callback method
 * could not be completed because of an unexpected error (e.g. the instance 
 * failed to open a database connection).
 */
public class EJBException extends java.lang.RuntimeException {
    /**
     * @serial
     */
    private Exception causeException = null;

    /**
     * Constructs an EJBException with no detail message.
     */  
    public EJBException() {
    }

    /**
     * Constructs an EJBException with the specified
     * detailed message.
     */  
    public EJBException(String message) {
        super(message);
    }

    /**
     * Constructs an EJBException that embeds the originally thrown exception.
     */  
    public EJBException(Exception  ex) {
        super();
	causeException = ex;
    }

    /**
     * Obtain the exception that caused the EJBException being thrown.
     */
    public Exception getCausedByException() {
	return causeException;
    }
}
