/*
 * $Id: Handle.java,v 1.6 1999/10/30 08:08:27 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb;

import java.rmi.RemoteException;

/**
 * The Handle interface is implemented by all EJB object handles. A handle
 * is an abstraction of a network reference to an EJB object. A handle is
 * intended to be used as a "robust" persistent reference to an EJB object.
 */
public interface Handle extends java.io.Serializable {
    /**
     * Obtain the EJB object reference represented by this handle.
     *
     * @exception RemoteException The EJB object could not be obtained
     *    because of a system-level failure.
     */
    public EJBObject getEJBObject() throws RemoteException;
}
