/*
 * $Id: HomeHandle.java,v 1.2 1999/10/30 08:08:28 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb;

import java.rmi.RemoteException;

/**
 * The HomeHandle interface is implemented by all home object handles. A handle
 * is an abstraction of a network reference to a home object. A handle is
 * intended to be used as a "robust" persistent reference to a home object.
 */
public interface HomeHandle extends java.io.Serializable {
    /**
     * Obtain the home object represented by this handle.
     *
     * @exception RemoteException The home object could not be obtained
     *    because of a system-level failure.
     */
    public EJBHome getEJBHome() throws RemoteException;
}
