/*
 * $Id: NoSuchEntityException.java,v 1.2 1999/10/30 08:08:29 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb;

/**
 * The NoSuchEntityException exception is thrown by an enterprise Bean 
 * instance to its container to report that the invoked business method 
 * or callback method could not be completed because of the underlying
 * entity was removed from the database. 
 *
 * <p>This exception may be thrown by the bean class methods that implement
 * the business methods defined in the bean's remote interface; and by 
 * the ejbLoad and ejbStore methods.
 */
public class NoSuchEntityException extends EJBException {
    /**
     * @serial
     */

    /**
     * Constructs an NoSuchEntityException with no detail message.
     */  
    public NoSuchEntityException() {
    }

    /**
     * Constructs an NoSuchEntityException with the specified
     * detailed message.
     */  
    public NoSuchEntityException(String message) {
        super(message);
    }

    /**
     * Constructs an NoSuchEntityException that embeds the originally 
     * thrown exception.
     */  
    public NoSuchEntityException(Exception  ex) {
        super(ex);
    }
}
