/*
 * $Id: ObjectNotFoundException.java,v 1.6 1999/10/30 08:08:30 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb;

/**
 * The ObjectNotFoundException exception is thrown by a finder method to
 * indicate that the specified EJB object does not exist.
 *
 * <p> Only the finder methods that are declared to return a single EJB object
 * use this exception. This exception should not be thrown by finder methods
 * that return a collection of EJB objects (they should return a null 
 * collection instead).
 */
public class ObjectNotFoundException extends FinderException {
    /**
     * Constructs an ObjectNotFoundException with no detail message.
     */  
    public ObjectNotFoundException() {
    }

    /**
     * Constructs an ObjectNotFoundException with the specified
     * detail message.
     */  
    public ObjectNotFoundException(String message) {
        super(message);
    }
}

