/*
 * $Id: SerializableField.java,v 1.3 1999/10/30 08:08:40 tcfujii Exp $
 *
 * Copyright 1998, 1999 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the proprietary information of Sun Microsystems, Inc.  
 * Use is subject to license terms.
 * 
 */

package javax.ejb.deployment;

import java.lang.reflect.Field;
import java.io.*;

/**
 * The class SerializableField is used internally as a serializable 
 * representation of the java.lang.reflect.Field class. This class is
 * transparent to the EJB API.
 *
 * <p> We use the field name and class name as the serializable representation
 * of a Field object.
 */
class SerializableField implements Serializable {
    SerializableField(Field field)
    {
	super();
	if (field != null) {
	    cls = field.getDeclaringClass();
	    fieldName = field.getName();
	}
    }

    Field getField()
	throws ClassNotFoundException, NoSuchFieldException
    {
	if (cls != null)
	    return cls.getField(fieldName);
	else
	    return null;
    }

    private Class cls = null;
    private String fieldName = null;
}
