//
//  Copyright (c) 1999, 2001
//  Sybase, Inc
//  Emeryville, CA 94608
//  All Rights Reserved
//
/**  
 *  A simple class for address data, to illustrate using a Java class
 *  as an SQL datatype.
 */  

public class  Address implements java.io.Serializable  {

   /**  
    *  The street data for the address.  
    *  @serial  A simple String value.
    */  
   public String street;
   /**  
    *  The zipcode data for the address.  
    *  @serial  A simple String value.
    */  
   public String zip;

   /**  
    *  A default constructor.  
    */  
   public Address ( ) {

      street = "Unknown";
      zip = "None";
   }

   /**  
    *  A constructor with parameters.
    *  @param S        a string with the street info
    *  @param Z        a string with the zipcode info
    */  
   public Address (String S, String Z) {
      street = S;
      zip = Z;
   }


   /**  
    *  A method to return a display of the address data.
    *  @returns   a string with a display version of the address data
    */  
   public String display( ) {
      return  "Street= " + street   
		+ "  ZIP=" + zip;
   }

   /**  
    *  A void method to remove leading blanks.
    *  This method uses the static method 
    *  <code>Misc.stripLeadingBlanks</code>.
    */  
   public void removeLeadingBlanks( ) {
      street = Misc.stripLeadingBlanks(street);
      zip = Misc.stripLeadingBlanks(street);
   }
}
