//
//  Copyright (c) 1999, 2001
//  Sybase, Inc
//  Emeryville, CA 94608
//  All Rights Reserved
//
/**  
 *  A subclass of the Address class to add a second line of address data.
 *  <p>This is a simple subclass to illustrate using a Java subclass
 *  as an SQL datatype.
 */  

public class Address2Line extends Address implements java.io.Serializable {
   /**  
    *  The second line of street data for the address.  
    *  @serial  a simple String value
    */  	
   public String line2;

   /**  
    *  A default constructor.  
    */  
   public Address2Line ( ) {
      street = "Unknown";
      line2 = " ";
      zip = "None";
   }

   /**  
    *  A constructor with parameters.
    *  @param S        a string with the street info
    *  @param L2       a string with the second line of address data
    *  @param Z        a string with the zipcode info
    */  

   public Address2Line (String S, String L2, String Z) {
      street = S;
      line2 = L2;
      zip = Z;
   }

   /**  
    *  A method to return a display of the address data.
    *  @returns   a string with a display version of the address data
    */  
   public String Display( ) {
      return "Street= " + street   
 	      + "Line2= " + line2 +  " ZIP= " + zip;
   }

   /**  
    *  A void method to remove leading blanks.
    *  This method uses the static method 
    *  <code>Misc.stripLeadingBlanks</code>.
    */  
   public void removeLeadingBlanks( ) {
      line2  = Misc.stripLeadingBlanks(line2);
      super.removeLeadingBlanks( );
   }
}

