//
//  Copyright (c) 1999, 2001
//  Sybase, Inc
//  Emeryville, CA 94608
//  All Rights Reserved
//
/**  
 *  A non-instantiable class with static methods to illustrate technical points
 *  regarding Java-SQL datatype mappings and null values.
 */  


public class General  {

   /**  
    *  The General class contains only static methods, and cannot be instantiated.
    */     
   private General() {}  

   /**  
    *  An int identity method.  
    *  <p>You can call this method from SQL, with an INTEGER argument.
    *  But, if the runtime value of the argument is null, 
    *  an SQL exception will be raised.
    */  
   public static int identity1(int I) {return I;}

   /**  
    *  An Integer identity method.
    *  <p>You can call this method from SQL, with an INTEGER argument.
    *  If the runtime value of the argument is null, 
    *  The Java parameter will be null.
    */  
   public static java.lang.Integer identity2(java.lang.Integer I) {
      return I;
   }

   /**  
    *  An Address identity method.
    *  <p>You can call this method from SQL, with an Address argument.
    *  If the runtime value of the argument is null, 
    *  The Java parameter will be null.
    */  

   public static Address identity3 (Address A) {return A;}
}
