//
//  Address.java
//
//  Copyright (c) 1998 
//  Sybase, Inc 
//  Emeryville, CA 94608
//  All Rights Reserved
//

package sample;

/**
 * The Address class is used by the HandleObject sample which shows how to 
 * insert, update and delete data stored as a Java Object in a Sybase Database.
 *
 * The HandleObject sample requires this class to be installed on the
 * targeted server.  Use the following instructions to install this class
 * file:
 *
 * 1) Build the samples using the Makefile (for Unix) or make_nt.bat (NT).
 * 2) Place the sample/Address.class file into a jar file:
 *    a) go to the $JDBC_HOME/classes directory
 *    b) run the jar command:
 *       jar cvf0 Address.jar sample/Address.class
 * 4) Install it onto the server
 *    a) for ASE (SQL Server), use:
 *       $SYBASE/bin/installjava -f <dir>/Address.jar -new -U sa -P passwd
 *    b) for ASA (Anywhere):
 *       install java new from file '<dir>/Address.jar'
 *
 * When running HandleObject sample, add the 'Address.jar' to the classpath.
 *
 */
public class Address implements java.io.Serializable 
{
    public String _street;
    public String _zip;

    // A default constructor
    public Address ( ) 
    {
        _street = "Unknown";
        _zip = "None";
    }

    // A constructor with parameters
    public Address (String s, String z) 
    {
        _street = s;
        _zip = z;
    }

    // A method to return a display representation of the full address
    public String display( ) 
    {
        return "Street= " + _street + " ZIP= " + _zip;
    }
}
